<?php

// get timezone
$a = exec( 'date -R | cut -d" " -f 6' );

if( $a[0] == '+' ) $c = 1;
elseif( $a[0] == '-' ) $c = -1;
else $c = 0;

if( $c != 0 )
{
	$offset = $c * (integer)$a[1] * 36000;
	$offset = $offset + $c * (integer)$a[2] * 3600;
	$offset = $offset + $c * (integer)$a[3] * 600;
	$offset = $offset + $c * (integer)$a[4] * 60;

	$tz = timezone_name_from_abbr( '', $offset, 1 );
	date_default_timezone_set( $tz );
}

// config
// MODIFICADO POR KAYETANO
$dbe1_config = array(
	'username' => 'root',
	'password' => 'dreambox',
	'address' => '192.168.0.141',
	'getEpg'  => true,
	'onEntry' => true,
	'onExit'  => true,
	'service' => '',
	'title'   => '',
);

if( is_file( $mos .'/www/modules/dbe1/dbe1.config.php' ) )
{
	include( $mos .'/www/modules/dbe1/dbe1.config.php' );
}
//
// ------------------------------------
function dbe1SaveConfig()
{
global $mos;
global $dbe1_config;

	file_put_contents( $mos .'/www/modules/dbe1/dbe1.config.php', '<?php $dbe1_config = '. var_export( $dbe1_config, true ). '; ?>' );
}
//
// ====================================
// html sets functions
// ====================================
function dbe1_sets_actions( $act, $log )
{
global $dbe1_config;

	if( $act == 'set' )
	{
		if( isset( $_REQUEST['address'] )) $dbe1_config['address'] = $_REQUEST['address'];
		$dbe1_config['getEpg' ] = isset( $_REQUEST['epg'] );
		$dbe1_config['onEntry'] = isset( $_REQUEST['entry'] );
		$dbe1_config['onExit' ] = isset( $_REQUEST['exit'] );

		dbe1SaveConfig();
	}
}

//
// ====================================
// RSS functions
// ====================================
// MODIFICADO POR KAYETANO
function dbe1Get( $request, $data = '', $xml = true )
{
global $dbe1_config;
	$username = $dbe1_config['username']; // secure server username to login
	$password = $dbe1_config['password']; // secure server password to login

	if( !is_array( $data ) && $data == '' )
	{
		$opts = array(
			'http' => array(
				'method'  => 'GET',
				'header'  => 'Content-type: application/x-www-form-urlencoded'.PHP_EOL.
						'Authorization: Basic '. base64_encode("$username:$password"),
			)
		);
	}
	else
	{					// GET
		$postdata = http_build_query( $data );
		$opts = array(
			'http' => array(
				'method'  => 'GET',
				'header'  => 'Content-type: application/x-www-form-urlencoded'.PHP_EOL.
						'Authorization: Basic '. base64_encode("$username:$password"),
						'content' => $postdata
			)
		);
		foreach( $data AS $k=>$v )
			$params[]= "$k=$v";

	}

	$context = stream_context_create( $opts );
	if( $xml )
		return file_get_contents( 'http://'. $dbe1_config['address'] . '/xml/' . $request, false, $context );
	else {
		$request .= '?'. join( '&', $params );
		return file( 'http://'. $dbe1_config['address'] . '/cgi-bin/' . $request, false, $context );
	}
}
//
// ------------------------------------
// 	MODIFICADO POR KAYETANO
function dbe1GetServices( $service )
{
//	$arrayData = array( 'ref'=>$service, 'listContent'=>'true' );
	$s=dbe1Get( 'getServices', $service, false );
	$b = array();
	foreach( $s as $service )
	{
		$service = explode( ';', $service );
		$ref = (string)$service[0];

		$ts = explode( ':', $ref );
		if( $ts[1] == 0 ) $t = 'stream';
		elseif( $ts[1] == 7 ) $t = 'bouquet';
		elseif( $ts[1] == 64 ) $t = 'delimiter';
		else $t = 'unknown';
		$b[ $ref ] = array(
			'name' => (string)$service[1],
			'type' => $t,
		  );
	}
	return $b;
}
//
// ------------------------------------
// 	MODIFICADO POR KAYETANO
define( 'epgnow', 0 );
define( 'epgnext', 1 );

function dbe1GetEpg( $service )
{
	$s=dbe1Get( 'serviceepg', array( 'ref'=>$service ) );
	$s = str_replace( "\x01", '', $s );

	$xml = simplexml_load_string( $s );
	$refService = (string)$xml->service->reference;

	$es = array();
	$attrName = 'id';
	foreach( $xml->event as $event )
	{
		$eventId = 0+$event->attributes()->$attrName;

		$es[ $refService ][ $eventId ] = array(
			'start' => (string)$event->start,
			'duration' => (string)$event->duration,
			'title' => (string)$event->description,
//			'details' => (string)$event->details,
		);
	}
	return $es;
}
//
// ------------------------------------
// 	MODIFICADO POR KAYETANO
function dbe1CheckState()
{
	$s=dbe1Get( 'boxstatus' );
	$xml = simplexml_load_string( $s );
	return trim( (string)$xml->standby ) == 0;
}
//
// ------------------------------------
// 	MODIFICADO POR KAYETANO
function dbe1_wakeup_content()
{
global $dbe1_config;

	header( "Content-type: text/plain" );

	if( ! $dbe1_config['onEntry'] ) return;
	if( dbe1CheckState() ) return;

	dbe1Get( 'admin', array( 'command'=>'wakeup' ), false );
}
//
// ------------------------------------
// 	MODIFICADO POR KAYETANO
function dbe1_standby_content()
{
global $dbe1_config;

	header( "Content-type: text/plain" );

	if( ! $dbe1_config['onExit'] ) return;
	if( ! dbe1CheckState() ) return;

	dbe1Get( 'admin', array( 'command'=>'standby' ), false );
}
//
// ------------------------------------
// 	MODIFICADO POR KAYETANO
function get_dbe1_content()
{
global $dbe1_config;

	if( isset($_REQUEST['ref']) && strlen($_REQUEST['ref']) ) {
		$service = $_REQUEST['ref'];
		dbe1Get( 'zapTo', array( 'path'=>$service ), false );

		header( "Content-type: text/plain" );
		echo 'http://'. $dbe1_config['address'] .':31344/'. urlencode( stripslashes( $service ));
	}
}
//
// ------------------------------------
function xml_dbe1_content()
{
global $dbe1_config;

	header( "Content-type: text/plain" );

	dbe1_wakeup_content();
	if( isset( $_REQUEST['service']))
	{
		$title = $_REQUEST['title'];
		$service= stripslashes( $_REQUEST['service'] );
	}
	else
	{
		$title = $dbe1_config['title'];
		$service = $dbe1_config['service'];
	}

	if( $service == '' )
	{
		$bs = dbe1GetServices( array( 'ref'=>'4097:7:0:6:0:0:0:0:0:0:', 'listContent'=>'false' ) );
		$service = key( $bs );
		$title = $bs[ $service ]['name'];
	}

	// save config
	$dbe1_config['title'] = $title;
	$dbe1_config['service'] = $service;
	dbe1SaveConfig();

	// get list of services
	$bs = dbe1GetServices( array( 'ref'=>$service, 'listContent'=>'true' ) );

	// get EPG for services
	$epg  = array();

	if( $dbe1_config['getEpg'] )
		$epg = dbe1GetEpg( $service );

	$items = array();
	foreach( $bs as $ref => $serv )
	{
		if( $serv['type'] == 'stream' ) {
			$c_epg = isset( $epg [ $ref ][epgnow] ) ? $c_epg = date( 'H:i', $epg [ $ref ][epgnow]['start'] ) .' '. $epg [ $ref ][epgnow]['title'] : '';
			$n_epg = isset( $epg[ $ref ][epgnext] ) ? $n_epg = date( 'H:i', $epg[ $ref ][epgnext]['start'] ) .' '. $epg[ $ref ][epgnext]['title'] : '';
	
			$img = getMosUrl() .'modules/dbe1/icons/'. strtoupper( str_replace( ':', '_', substr( $ref, 0, count( $ref ) - 2 )) ). '.png';
	
			$items[] = array(
				'ref' => $ref,
				'name' => $serv['name'],
				'image' => $img,
				'current' => $c_epg,
				'next' => $n_epg
			);
			// generate raw text for RSS
			$s1 .= $serv['name'] .PHP_EOL. $img .PHP_EOL. $ref .PHP_EOL. $c_epg .PHP_EOL. $n_epg .PHP_EOL;
		}
	}

	// save list
	file_put_contents( '/tmp/dbe1.list.php', '<?php $items = '. var_export( $items, true ). '; ?>' );

	// generate raw text for RSS
	$s = $title .PHP_EOL ;
	$s .= count( $items ) . PHP_EOL;
	$s .= $s1;

	if( isset( $_REQUEST['debug']))
	{
		echo $s;
	}
	else
	{
		file_put_contents( '/tmp/put.dat', $s );
		echo "/tmp/put.dat";
	}

}
//
// ------------------------------------
function rss_dbe1_menu_content()
{
	include( 'modules/core/rss_view_left.php' );

	$view = new rssSkinLeftView;

	$view->items = array(
		0 => array(
			'title'	=> getMsg('dbe1_Bouquet'),
			'action'=> 'rss',
			'link'	=> getMosUrl().'?page=rss_dbe1_list&amp;list=bouquets'
		),
		1 => array(
			'title'	=> getMsg('dbe1_Provider'),
			'action'=> 'rss',
			'link'	=> getMosUrl().'?page=rss_dbe1_list&amp;list=providers'
		)
	);

	$view->showRss();
}
//
// ------------------------------------
function rss_dbe1_list_content()

{
	if( ! isset( $_REQUEST['list'] )) return;

	$service = array( 'ref'=>'4097:7:0:6:0:0:0:0:0:0:', 'listContent'=>'false' );
	if( $_REQUEST['list'] == 'providers' ) {
		// SORT BY PROVIDERS
//		$service = '1:7:1:0:0:0:0:0:0:0:(type == 1) || (type == 17) || (type == 195) || (type == 25) FROM PROVIDERS ORDER BY name';
	} else {
		// SORT BY BOUQUETS
		$service = array( 'ref'=>'4097:7:0:6:0:0:0:0:0:0:', 'listContent'=>'false' );
	}

	$bs = dbe1GetServices( $service );

	include( 'modules/core/rss_view_left.php' );

	$view = new rssSkinLeftView;

	$view->position = 1;

	foreach( $bs as $ref => $serv )
	{
		$view->items[] = array(
			'title'	=> $serv['name'],
			'action'=> 'ret',
			'link'	=> getMosUrl().'?page=xml_dbe1&amp;service='. urlencode( $ref ) .'&amp;title='. urlencode( $serv['name'] )
		);
	}

	$view->showRss();
}
//
// ------------------------------------
function rss_dbe1_player_content()
{
	if( ! is_file( '/tmp/dbe1.list.php' ) ) return;
	include( '/tmp/dbe1.list.php' );

	if( count( $items ) == 0 ) return;

	include( 'modules/core/rss_view_player.php' );
	class rssEnigmaPlayerView extends rssSkinPlayerView
	{
		const titleX		= 148;
		const titleY		= 0;
		const titleWidth	= 712;
		const titleHeight	= 150;

		const iconX		= 40;
		const iconY		= 10;
		const iconWidth		= 100;
		const iconHeight	= 60;

		const statusX		= 1134;
		const statusY		= 25;
		const statusWidth	= 30;
		const statusHeight	= 30;
	}
	$view = new rssEnigmaPlayerView;

	foreach( $items as $item )
	 $view->items[] = array(
		'title' => $item['name'],
		'link'  => getMosUrl(). '?page=get_dbe1&amp;ref='. urlencode( $item['ref'] ),
		'action'=> 'get',
		'image' => $item['image']
	 );

	$view->cItem = 0;
	if( isset( $_REQUEST['id'] )) $view->cItem = $_REQUEST['id'];

	$view->showRss();
}
//
// ------------------------------------
function rss_dbe1_content()
{
	class rssEnigmaView extends rssSkinHTile
	{
		const itemWidth		= 400;
		const itemHeight	= 90;
		//
		// ------------------------------------
		public $topTitle =
'
	<script>
	  topTitle;
	</script>';
		//
		// ------------------------------------
		public $fields = array(
			0 => array(			// image
				'type'   => 'image',
				'posX'   => 10,
				'posY'   => 15,
				'width'  => 100,
				'height' => 60,
				'image'  => '
	<script>
	  getStringArrayAt(imgArray, idx);
	</script>'
			),
			1 => array(			// title
				'type'    => 'text',
				'posX'    => 110,
				'posY'    => 10,
				'width'   => 280,
				'height'  => 28,
				'lines'   => 0,
				'fontSize'=> 12,
				'align'   => 'left',
//				'bgColor' => '"100:100:100"',
				'text'    => '
	<script>
	  getStringArrayAt(nameArray, idx);
	</script>'
			),
			2 => array(			// current
				'type'    => 'text',
				'posX'    => 110,
				'posY'    => 40,
				'width'   => 280,
				'height'  => 20,
				'lines'   => 1,
				'fontSize'=> 8,
				'align'   => 'left',
//				'bgColor' => '"100:100:100"',
				'text'    => '
	<script>
	  getStringArrayAt(currArray, idx);
	</script>'
			),
			3 => array(			// next
				'type'    => 'text',
				'posX'    => 110,
				'posY'    => 60,
				'width'   => 280,
				'height'  => 20,
				'lines'   => 1,
				'fontSize'=> 8,
				'align'   => 'left',
//				'bgColor' => '"100:100:100"',
				'text'    => '
	<script>
	  getStringArrayAt(nextArray, idx);
	</script>'
			),
		);
		//
		// ------------------------------------
		public function showItemDisplay()
		{

?>
    <itemDisplay>
      <script>
	idx = getQueryItemIndex();
	drawState = getDrawingItemState();
	if (drawState == "unfocus")
	{
		border = "<?= getSkinPath().static::imageUnFocus ?>";
		color = "<?= static::unFocusFontColor ?>";
	}
	else
	{
 		border = "<?= getSkinPath().static::imageFocus ?>";
		color = "<?= static::focusFontColor ?>";
	}
      </script>
      <image redraw="no" offsetXPC="0" offsetYPC="0" widthPC="100" heightPC="100">
        <script>
            border;
        </script>
      </image>
<?php
			foreach( $this->fields as $info )
			{
				$px = round( $info['posX'] / static::itemWidth * 100, 4);
				$py = round( $info['posY'] / static::itemHeight * 100, 4);
				$pw = round( $info['width']  / static::itemWidth  * 100, 4);
				$ph = round( $info['height'] / static::itemHeight * 100, 4);

				if( $info['type'] == 'image' )
				{

?>
      <image offsetXPC="<?= $px ?>" offsetYPC="<?= $py ?>" widthPC="<?= $pw ?>" heightPC="<?= $ph ?>" ><?= $info['image'] ?> 
      </image>
<?php
				}
				else
				{
					$pa = isset( $info['align'] )    ? $info['align']     : static::itemTextAlign;
					$ps = isset( $info['fontSize'] ) ? $info['fontSize']  : static::itemTextFontSize;
					$pb = isset( $info['bgColor'] )  ? $info['bgColor']   : '"'. static::itemTextBackgroundColor .'"';
					$pf = isset( $info['fgColor'] )  ? $info['fgColor']   : 'color';

					$pl = isset( $info['lines'] ) ? $info['lines'] : static::itemTextLines;
					$pl = ( $pl > 0 ) ? ' lines="'. $pl .'"' : '';

?>
      <text offsetXPC="<?= $px ?>" offsetYPC="<?= $py ?>" widthPC="<?= $pw ?>" heightPC="<?= $ph ?>"
       align="<?= $pa ?>"<?= $pl ?> fontSize="<?= $ps ?>">
	<backgroundColor>
          <script>
            <?= $pb ?>;
          </script>
	</backgroundColor>
	<foregroundColor>
          <script>
            <?= $pf ?>;
          </script>
	</foregroundColor><?= $info['text'] ?> 
      </text>
<?php
				}
			}

?>
    </itemDisplay>
<?
		}
		//
		// ------------------------------------
		function showMoreDisplay()
		{
?>
    <text redraw="yes" align="center" lines="1" fontSize="22"
     offsetXPC="18.2353" offsetYPC="15.625" widthPC="63.5294" heightPC="7.8125"
     backgroundColor="-1:-1:-1"
     foregroundColor="<?= static::unFocusFontColor ?>">
      <script>
	msgText;
      </script>
    </text>
<?php
		}
		//
		// ------------------------------------
		public function showOnUserInput()
		{
?>
    <onUserInput>
	ret = "false";
	i = getFocusItemIndex();
	userInput = currentUserInput();

	if (userInput == "<?= getRssCommand('up') ?>")
	{
		if( ( i % <?= $this->_rowCount ?> ) == 0 ) ret = "true";
	}
	else if (userInput == "<?= getRssCommand('down') ?>")
	{
		if( ( ( i - -1 ) % <?= $this->_rowCount ?> ) == 0 ) ret = "true";
	}
	else if (userInput == "<?= getRssCommand('enter') ?>")
	{
		showIdle();
		url = "<?= getMosUrl().'?page=get_dbe1' ?>"
		 + "&amp;ref=" + urlEncode( getStringArrayAt( urlArray, i ));
		url = getUrl(url);
		if(( url != null )&amp;&amp;( url != "" ))
		{
			playItemURL( url, 0 );
		}
		cancelIdle();
		ret = "true";
	}
	else if (userInput == "<?= getRssCommand('play') ?>")
	{
		showIdle();
		url = "<?= getMosUrl().'?page=rss_dbe1_player' ?>" + "&amp;id=" + i;
		doModalRss( url );
		cancelIdle();
		ret = "true";
	}
	else if (userInput == "<?= getRssCommand('menu') ?>" || userInput == "<?= getRssCommand('rewind') ?>")
	{
	        url = "<?= getMosUrl().'?page=rss_dbe1_menu' ?>";
		url = doModalRss( url );
		if(( url != null )&amp;&amp;( url != "" ))
		{
			moUrl = url;
			savedItem = 0;
			setRefreshTime(1);
		}
		ret = "true";
	}
	ret;
    </onUserInput>
<?php
		}
		//
		// ------------------------------------
		public function showScripts()
		{
?>

  <onEnter>
	moUrl = "<?= getMosUrl().'?page=xml_dbe1' ?>";
	savedItem = 0;
	setRefreshTime(1);
  </onEnter>

  <onRefresh>
	setRefreshTime(-1);
	showIdle();
	itemCount = 0;

	dlok = getURL( moUrl );
	if (dlok != null) dlok = readStringFromFile( dlok );
	if (dlok != null)
	{
		c = 0;
		topTitle = getStringArrayAt(dlok, c); c += 1;

		itemCount = getStringArrayAt(dlok, c); c += 1;

		nameArray = null;
		imgArray  = null;
		urlArray  = null;
		currArray = null;
		nextArray = null;

		count = 0;
		while( count != itemCount )
		{
			nameArray = pushBackStringArray( nameArray, getStringArrayAt(dlok, c)); c += 1;
			imgArray  = pushBackStringArray( imgArray,  getStringArrayAt(dlok, c)); c += 1;
			urlArray  = pushBackStringArray( urlArray,  getStringArrayAt(dlok, c)); c += 1;
			currArray = pushBackStringArray( currArray, getStringArrayAt(dlok, c)); c += 1;
			nextArray = pushBackStringArray( nextArray, getStringArrayAt(dlok, c)); c += 1;

			count += 1;
		}
	}
	msgText = "";
	if( itemCount == 0 )
	{
		msgText = "<?= getMsg('coreRssPromptNothing') ?>";
		setFocusItemIndex( 0 );
	}
	else
	{
		if( savedItem &gt; ( itemCount - 1 ))
		{
			setFocusItemIndex( itemCount - 1 );
		}
		else setFocusItemIndex( savedItem );
	}

	cancelIdle();
	redrawDisplay();
  </onRefresh>

  <onExit>
	setRefreshTime(-1);
	playItemURL( -1, 1 );
	getURL( "<?= getMosUrl().'?page=dbe1_standby' ?>" );
  </onExit>

<?php
		}
		//
		// ------------------------------------
		public function showChannel()
		{
?>
  <channel>
    <itemSize>
      <script>
	itemCount;
      </script>
    </itemSize>
  </channel>
<?php
		}
	}

	$view = new rssEnigmaView;

	$view->bottomTitle = 
		  getRssCommandPrompt('menu')  . getMsg( 'coreRssPromptMenu' )
		. getRssCommandPrompt('play')  . getMsg( 'coreRssPromptWatch' )
		. getRssCommandPrompt('enter') . getMsg( 'dbe1_WatchList' )
//		. getRssCommandPrompt('stop')  . getMsg( 'coreRssPromptActs' )
	;

	$view->showRss();

}
?>
